﻿--[[--example
	local func = {};
	func.name = "print";
	func.callback = function() print("test.") end;
	UnitFramesPlus_WaitforCall(func);
--]]

local ufpcbl = {--callbacklist
	count = 0;
	locked = false; --locked when called
	list = {}; -- list
};

local ufpcblsc = { --second callbacklist
	empty = true;
	count = 0;
	locked = false;
	list = {};
};

function UnitFramesPlus_WaitforCall(func)
	local id;
	if ufpcbl["locked"] == false then
		ufpcbl["count"] = ufpcbl["count"] + 1;
		ufpcbl["list"][ufpcbl["count"]] = {};

		for id = 1, ufpcbl["count"]-1, 1 do
			if ufpcbl["list"][id].name == func.name then
				ufpcbl["list"][id].valid = false;
				break;
			end
		end

		ufpcbl["list"][ufpcbl["count"]].name = func.name;
		ufpcbl["list"][ufpcbl["count"]].callback = func.callback;
		ufpcbl["list"][ufpcbl["count"]].valid = true;
	else
		ufpcblsc["count"] = ufpcblsc["count"] + 1;
		ufpcblsc["list"][ufpcblsc["count"]] = {};

		for id = 1, ufpcblsc["count"]-1, 1 do
			if ufpcblsc["list"][id].name == func.name then
				ufpcblsc["list"][id].valid = false;
				break;
			end
		end

		ufpcblsc["list"][ufpcbl["count"]].name = func.name;
		ufpcblsc["list"][ufpcbl["count"]].callback = func.callback;
		ufpcblsc["list"][ufpcbl["count"]].valid = true;
		if ufpcblsc["empty"] == true then ufpcblsc["empty"] = false end
	end
end

local function UnitFramesPlus_Call()
	local id;
	if ufpcblsc["empty"] == false and ufpcblsc["locked"] == false then
		ufpcblsc["locked"] = true;
		for id = 1, ufpcblsc["count"], 1 do
			if ufpcblsc["list"][id].valid == true then
				if InCombatLockdown() then
					ufpcblsc["locked"] = false;
					return;
				end
				ufpcblsc["list"][id].callback();
				ufpcblsc["list"][id].valid = false;
			end
		end
		ufpcblsc["list"] = {};
		ufpcblsc["count"] = 0;
		ufpcblsc["locked"] = false;
		ufpcblsc["empty"] = true;
	end

	if ufpcbl["locked"] == false then
		ufpcbl["locked"] = true;
		for id = 1, ufpcbl["count"], 1 do
			if ufpcbl["list"][id].valid == true then
				if InCombatLockdown() then
					ufpcbl["locked"] = false;
					return;
				end
				ufpcbl["list"][id].callback();
				ufpcbl["list"][id].valid = false;
			end
		end
		ufpcbl["list"] = {};
		ufpcbl["count"] = 0;
		ufpcbl["locked"] = false;
	end
end

local ufpcb = CreateFrame("Frame");
ufpcb:RegisterEvent("PLAYER_REGEN_ENABLED");
ufpcb:SetScript("OnEvent", function(self, event)
	UnitFramesPlus_Call();
end)
